import numpy as np

cD = cI = cR = 1

def EditDistance(m, s, n, t, D):
    for i in range(1, m+1):
        D[i,0] = i * cD
    for j in range(1, n+1):
        D[0,j] = j * cI
    for i in range(1, m+1):
        for j in range(1, n+1):
            if s[i] == t[j]:
                mincost = D[i-1,j-1]
            else:
                delcost = D[i-1,j  ] + cD
                inscost = D[i,  j-1] + cI
                repcost = D[i-1,j-1] + cR
                mincost = min( delcost, inscost, repcost )
            D[i,j] = mincost
    return D[m,n]

def EditOps(i, s, j, t, D):
    if i == 0 and j == 0: return
    opt = D[i,j]

    lft = np.inf
    if i > 1: lft = D[i-1,j] + cD
    top = np.inf
    if j > 1: top = D[i,j-1] + cI
    dia = np.inf
    if i > 1 and j > 1:
        if s[i] == t[j]:
            dia = D[i-1,j-1]
        else:
            dia = D[i-1,j-1] + cR

    if opt == lft:
        EditOps(i-1, s, j, t, D)
        print(f'{"delete":<10}{cD:<5}{s[i]:<6}{"-"}') 
    elif opt == top:
        EditOps(i, s, j-1, t, D)
        print(f'{"insert":<10}{cI:<5}{"-":<6}{t[j]}') 
    else:
        EditOps(i-1, s, j-1, t, D)
        if s[i] == t[j]:
            print(f'{"copy":<10}{0:<5}{s[i]:<6}{s[i]}')
        else:
            print(f'{"replace":<10}{cR:<5}{s[i]:<6}{t[j]}')

s = ' sunday'
m = len(s)-1
t = ' saturday'
n = len(t)-1

D = np.zeros((m+1,n+1), np.int32)
opt = EditDistance(m, s, n, t, D)
print(f'---------------------------')
print(f'operation cost input output')
print(f'---------------------------')
EditOps(m, s, n, t, D)
print(f'---------------------------')
print(f'Edit distance between {s[1:]} and {t[1:]} is {opt}')

