import numpy as np

n = 7
w = np.array([0, 2, 3, 5, 7, 1, 4, 1], dtype=np.int32)
v = np.array([0, 10, 5, 15, 7, 6, 18, 3], dtype=np.int32)
W = 15

K = np.empty((n+1,W+1), dtype=np.int32)
K[0,:] = 0
K[:,0] = 0

for i in range(1,n+1):
    for j in range(1,W+1):
        if j - w[i] >= 0:
            K[i,j] = max( K[i-1,j], v[i] + K[i-1,j-w[i]] )
        else:
            K[i,j] = K[i-1,j] 

opt = K[n,W]
cap = W
print(f'Optimal solution = {opt}')
print(f'Knapsack items:', end=' ')
for i in range(n, 0, -1):
    if K[i-1,cap] == opt: continue
    print(f'{i}(w = {w[i]}, v = {v[i]})', end=' ')
    opt = opt - v[i]
    cap = cap - w[i]
print()

